; Interface

;WriteTextToWindow
macro Text xStart,yStart,rgbColor,pText,nTextLen
{
 mov ebx,xStart
 shl ebx,16
 add ebx,yStart
 mov ecx,rgbColor
 mov edx,pText
 mov esi,nTextLen
 mov eax,4
 int 0x40
}

;DisplayNumber
macro Number xStart,yStart,nPrintType,noOfDigits,Data,rgbColor
{
 mov edx,xStart
 shl edx,16
 add edx,yStart
 mov ebx,noOfDigits
 shl ebx,16
 or ebx,nPrintType
 mov ecx,Data
 mov esi,rgbColor
 mov eax,47
 int 0x40
}

macro DrawLine xStart,xEnd,yStart,yEnd,rgbColor
{
 mov ebx,xStart
 shl ebx,16
 add ebx,xEnd
 mov ecx,yStart
 shl ecx,16
 add ecx, yEnd
 mov edx,rgbColor
 mov eax,38
 int 0x40
}

decode_standard:

comp0:
cmp [b1s], 00b
je S25

comp1:
cmp [b1s], 01b    ; unknown
je S25

comp2:
cmp [b1s], 10b
je S20

comp3:
cmp [b1s], 11b
je S10

jmp S000

;-----

S25:
mov [S1], 2
mov [S2], 5
mov [id], 3  ;lowest freq
jmp S000

S20:
mov [S1], 2
mov [S2], 0
mov [id], 2  ;low freq
jmp S000

S10:
mov [S1], 1
mov [S2], 0
mov [id], 1  ;hi freq
jmp S000

S000:

ret




decode_layer:

com0:
cmp [b1l], 00b
je L3         ; unknown

com1:
cmp [b1l], 01b
je L3

com2:
cmp [b1l], 10b
je L2

com3:
cmp [b1l], 11b
je L1

jmp L000

;-----

L3:
mov [La], 3
jmp L000

L2:
mov [La], 2
jmp L000

L1:
mov [La], 1
jmp L000

L000:

ret



decode_channels:

co0:
cmp [shan], 00b
je C4         

co1:
cmp [shan], 01b
je C3

co2:
cmp [shan], 10b
je C2

co3:
cmp [shan], 11b
je C1

jmp C000

;-----
C4:
mov [K], 4 ;00=Stereo
jmp C000

C3:
mov [K], 3 ;01=Joint stereo 
jmp C000

C2:
mov [K], 2 ;10=Dual Channel
jmp C000

C1:
mov [K], 1 ;11=Single Channel (Mono)
jmp C000

C000:

ret

;--------------------------
;  decode_samplerate
;--------------------------
decode_samplerate:
   push  eax
   push  ecx

   mov	 eax, [sam]
   mov	 eax, [freq + eax*4]
   mov	 ecx, [b1s]
   cmp	 cl, 01      ; bad frequency
   jnz	 ok

ok:
   cmp	 cl, 0
   jz	 @f
   dec	 cl
@@:
   shl	 eax, cl
   mov	 [SR], eax

   pop	 ecx
   pop	 eax
ret


;--------------------------
;  decode_bitrate
;--------------------------
decode_bitrate:
   push  eax
   mov	 eax, [b1s]
   test  eax, 1
   jz	 v2
   mov	 eax, [b1l]
   dec	 eax
   imul  ax, 16
   add	 eax, [Bita]
   mov	 ax, word [Bitrate_v1+eax*2]
   mov	 [BR], eax
   jmp	 end_br

v2:
   mov	 eax, [b1l]
   cmp	 al, 3
   jb	 l2_3
   mov	 eax, [Bita]
   mov	 ax, word [Bitrate_v2_l1 + eax*2]
   mov	 [BR], eax
   jmp	 end_br

l2_3:
   mov	 eax, [Bita]
   mov	 ax, word [Bitrate_v2_l2 + eax*2]
   mov	 [BR], eax
   jmp	 end_br
end_br:
   pop	 eax
ret