;******************************************************************************
; project name:    SuperMP3
; target platform: MenuetOS, x86 (IA-32), x86-64 achitecture
; compiler:        flat assmebler 1.60
; version:         0.3.1
; last update:     26th April 2005
; maintained by:   Sergey Kuzmin aka Wildwest
; e-mail:          kuzmin_serg@list.ru
;******************************************************************************
; Summary:
; initial reader for mp3's headers
; can read mostly needed parts from headers of CLEAN mp3
; (without tag or RIFF_header in the beginning)
; can be used later in tag editor, mp3 player or converter
;******************************************************************************
;HISTORY:
;0.3.1
;Author:    Alexei Ershov aka ealex <e-al@yandex.ru>
;Features:  rewrited decode_samplerate and decode_bitrate
;------------------------------------------------------------------------------
;0.3:       SuperMP3 (not finished and its future in the dark)   04/26/2005
;Author:    Sergey Kuzmin aka Wildwest <kuzmin_serg@list.ru>
;Features:  added File_size and Duration (rough estimation), improved SampleRate, fixed BitRate
;--------------------------------------------------------------------------------------
;0.2:       SuperMP3 (not finished and its future in the dark)   04/21/2005
;Author:    Sergey Kuzmin aka Wildwest <kuzmin_serg@list.ru>
;Features:  added SampleRate and BitRate
;------------------------------------------------------------------------------
;0.1:       SuperMP3 (not finished and its future in the dark)   04/20/2005
;Author:    Sergey Kuzmin aka Wildwest <kuzmin_serg@list.ru>
;Features:  able to detect MPEG Version, Layer, Channels
;------------------------------------------------------------------------------
;Issues: I don't have complete information about mp3 header :(
;And I don't start mp3 player, because it needs work of several men
;during several months!(approx. 10 men and 2-4 months, because it is ASM OS).
;-----------------------------------------------------------------------------
;CLEAN mp3 - is mp3 without any info before header.
;Open mp3 in HEX EDITOR and check it.

;Usually nornal header's start looks like FFF3 or FFFB.

;If you see TAG (4944 3303 = ID3.) or RIFF (5249 46 46 = RIFF)
;or (0000 0000 - encoded by Lame codec or another shitty program)-it is bad,
;you must delete this piece until FFFx before testing. Good testing!

;Note - I test it only on ONE file (test.mp3,
;which included in this package) in Bochs.

;  

    use32
    org    0x0
    db	   'MENUET01'		   ; 8 byte id
    dd	   0x01 		   ; header version
    dd	   START		   ; start of code
    dd	   I_END		  ; size of image
    dd	   0x9000		 ; memory for app
    dd	   0x9000		 ; esp
    dd	   0x0	       ; I_Param , I_Icon
	dd     0x0

include "MACROS.INC"
include "MOS_UZIT.INC"

START:

;  

    mov  eax,58
    mov  ebx,fileinfo
    int  0x40

result:
mov dword [size], ebx
mov eax, dword [mp3_file]

;------------------------------------------------------
;file test.mp3 have these 4 first bytes: FFh F3h 74h 54h.
;But since it is f*cking "little endian" platform, we got:
;54h 74h F3h FFh.
;Who was that idiot in Intel, which produce idea of this horrible x86?
;Anyway we have this:
;(01)01_0100 || (0111)_(01)00 || 111 (1_0) (01) 1 || 1111_1111
;------------------------------------------------------

;in byte 54h we have
;bits
;     7..6  Channels

;in byte 74h we have
;bits
;     7..4 Bitrate
;         3..2 Sample Rate


;in bytes FFh F3h we have
;bits  7 6 5 4 3 2 1 0 | 7 6 5  Sync Header  (must be 0xFFEx)
;bits                           4 3 2 1 0
;     4..3  Standart (MPEG version)
;     2..1  Layer
;------------------------ Channels
mov edx, eax
;and edx, F0000000h;
shr edx, 30

mov dword[shan], edx
;-------------------- Sample Rate
xor ebx, ebx

mov ebx, eax
shr ebx, 16
and ebx, 0000000Fh
shr ebx, 2

mov dword [sam], ebx
;----------------------- Standart
xor ebx, ebx

mov ebx, eax
and ebx, 0000FF00h;
shr ebx, 9
and ebx, 0000000Fh;

mov ecx, ebx

shr ecx, 2
mov dword [b1s], ecx
;------------------------- Layer
and ebx, 00000003h
mov dword [b1l], ebx
;------------------------- Bitrate
xor edx, edx
mov edx, eax
shr edx, 20
and edx, 0000000Fh

mov dword[Bita], edx
;-------------------------

call decode_standard

call decode_layer

call decode_channels

call decode_samplerate

call decode_bitrate

xor eax, eax
xor ebx, ebx
xor ecx, ecx
xor edx, edx

mov ebx, dword[BR]
imul ebx, 125
; result in ebx


mov eax, dword[size]

div ebx


mov dword[time], eax

;mov dword[leax], eax
;mov dword[lebx], ebx
;mov dword[lecx], ecx
;mov dword[ledx], edx


	;  
   draw_window:
	 mov  eax,12		; function 12:tell os about windowdraw
	mov  ebx,1		; 1, start of draw
	int  0x40
	mov  eax,0		; function 0 : define and draw window
	mov  ebx,250 shl 16 + 300
	mov  ecx,250 shl 16 + 180
	mov  edx,0x03aabbcc	; color of work area RRGGBB,8->color gl
	int  0x40
	Text 8,8,0x20ddeeff,zag, zaglen -zag


      Text 20,40,0x00000000,S, Slen-S
      Number 110,40,1*256,1,dword [S1],0x000000;
      Number 122,40,1*256,1,dword [S2],0x000000;

	  Text 20,60,0x00000000,L, Llen-L
      Number 70,60,1*256,1,dword [La],0x000000

	  Text 20,100,0x00000000,SamR, SamRlen-SamR
	  Number 110,100,0*256,5,dword [SR],0x000000

	  Text 20,120,0x00000000,BitR, BitRlen-BitR
	  Number 110,120,0*256,3,dword [BR],0x000000

	  Text 20,140,0x00000000,Sizebyte, Sizebytelen-Sizebyte
      Number 70,140,0*256,8,dword [size],0x000000

	  Text 20,160,0x00000000,Timese, Timeselen-Timese
	  Number 70,160,0*256,4,dword [time],0x000000

	 ; Number 70,200,0*256,15,dword [leax],0x000000
	 ; Number 70,220,0*256,15,dword [lebx],0x000000
	 ; Number 70,240,0*256,15,dword [lecx],0x000000
	 ; Number 70,260,0*256,15,dword [ledx],0x000000

	  Text 20,80,0x00000000,Ka, Kalen-Ka

	 cmp [K], 1
	 je rez1
	 cmp [K], 2
	 je rez2
	 cmp [K], 3
	 je rez3
	 cmp [K], 4
	 je rez4

	 rez1:
	 Text 110,80,0x00000000,SC, SClen-SC
	 jmp next
	 rez2:
	 Text 110,80,0x00000000,DC, DClen-DC
	  jmp next
	 rez3:
	 Text 110,80,0x00000000,JOS, JOSlen-JOS
	  jmp next
	 rez4:
	 Text 110,80,0x00000000,Su, Sulen-Su

next:

    mov  eax,12
    mov  ebx,2
    int  0x40


	;     
   get_event:
	mov  eax,10
	int  0x40
	dec	eax
	jz	draw_window
	;    ,  
	;  
   click_on_button:
   exit:
	mov  eax,-1
       int  0x40

   freq  dd   11025, 12000, 8000
   Bitrate_v1 dw 0,32,40,48, 56, 64, 80, 96,112,128,160,192,224,256,320,0,\
		 0,32,48,56, 64, 80, 96,112,128,160,192,224,256,320,384,0,\
		 0,32,64,96,128,160,192,224,256,288,320,352,384,416,448,0

   Bitrate_v2_l1 dw 0,32,48,56,64,80,96,112,128,144,160,176,192,224,256,0
   Bitrate_v2_l2 dw 0, 8,16,24,32,40,48, 56, 64, 80, 96,112,128,144,160,0
   b1s dd ?   ; standard
   b1l dd ?   ; layer

   S1 dd ?
   S2 dd ?
   La dd ?
   shan dd ?
   K dd ?
   sam dd ?
   id dd ?
   SR dd ?
   Bita dd ?
   BR dd ?
   size dd ?
   time dd ?
   ;leax dd ?
   ;lebx dd ?
   ;lecx dd ?
   ;ledx dd ?
zag:
     db   'SuperMP3 0.3 by Sergey Kuzmin aka Wildwest'
zaglen:

S:
    db 'MPEG Version:   .  '
Slen:

L:
    db 'Layer:   '
Llen:

Ka:
    db 'Channels Mode:   '
Kalen:

Su:
    db 'Stereo'
Sulen:

JOS:
    db 'Joint stereo '
JOSlen:

DC:
    db 'Dual channel'
DClen:

SC:
    db 'Single Channel (Mono)'
SClen:

SamR:
    db 'Sample Rate:          Hz'
SamRlen:

BitR:
    db 'BitRate:            Kbps'
BitRlen:

Sizebyte:
    db 'Size:            bytes'
Sizebytelen:

Timese:
    db 'Time:            seconds'
Timeselen:

;  1   512    .
;    mp3_file
;      0x1000
 fileinfo:
  dd 0, 0, 1, mp3_file, 0x2000
  db "/RD/1/TEST.MP3",0

I_END:

label  mp3_file dword at 0x2000

